#ifndef INCLUDE__Mainwindow_hxx_
#define INCLUDE__Mainwindow_hxx_

#include <memory>
#include <map>
#include <QTextEdit>
#include <QPushButton>
#include <QMainWindow>
#include <QListWidget>
#include <QStackedWidget>

#include "disassembler/Disassembler.hxx"
#include "widgets/BasicBlockWidget.hxx"
#include "widgets/ScriptingDock.hxx"

class Mainwindow : public QMainWindow {
    Q_OBJECT
public:
    Mainwindow(const std::string& filename = "");
private:
	void openBinary(const std::string& filename);

    void populateSymbolInformation(Function * fun);

    QTextEdit *textEdit;
    QPushButton *quitButton;
    QMenu *fileMenu;

    QTabWidget * tabwidget;
    QListWidget * listWidget;
    QStackedWidget * stackedWidget;
    QDockWidget * dockWidget;
    ScriptingDock * scripting;

    QAction *exitAction;
    QAction *openAction;

    std::shared_ptr<Disassembler> disassembler;
	std::map<uint64_t, BasicBlockWidget*> blocks;
private Q_SLOTS:
    void quit();
    void open();
};

#endif /* INCLUDE__Mainwindow_hxx_ */
